An non-ascii identifier was used in an invalid context.

Erroneous code examples:

```compile_fail,E0754
# #![feature(non_ascii_idents)]

mod řųśť; // error!

#[no_mangle]
fn řųśť() {} // error!

fn main() {}
```

Non-ascii can be used as module names if it is inlined or if a `#[path]`
attribute is specified. For example:

```
# #![feature(non_ascii_idents)]

mod řųśť { // ok!
    const IS_GREAT: bool = true;
}

fn main() {}
```
